### ===================================================================================================================
###                                                       VIIA
###                                                  Objectnr: XXXX
###                                            Structural engineer: Name
### ===================================================================================================================
# TEMPLATE SERVER SCRIPT v1.4
# Copyright VIIA
# For more information, please see the how to use server template session in protocol

# =====================================================================================================================
#                                                  Initial startup
# =====================================================================================================================

# Import the viiaPackage
from viiapackage import *

# =====================================================================================================================
#                                                  User Input
# =====================================================================================================================

# Booleans, ideally set all to true to perform the entire process automatically
run_mainscript = True  # Runs mainscript to create the .dat and .dcf files, set to false if files are already generated
run_analysis = True  # Runs the analysis in the cmd
result_handling = True  # Runs the resultscript to obtain result files and pictures

signal = 'S1'  # Should be consistent with the signal indicated in the mainscript and resultscript!
project_name = 'XXXX'

# =====================================================================================================================
#                          Step 1: Create model in DianaIE -> dat-file and dcf-file
# =====================================================================================================================

# Create the project
project = viia_create_project(project_name=project_name)

# Retrieve the mainscript and resultscript
current_directory = Path.cwd()
mainscript_path = project.viia_get_scripts_in_folder(folder=current_directory, file='mainscript')
resultscript_path = project.viia_get_scripts_in_folder(folder=current_directory, file='resultscript')

# Check if 'model' folder and 'user_config' are in folder
model_path = project.viia_get_subfolder_in_folder(folder=current_directory, subfolder='model')
user_config_path = project.viia_get_scripts_in_folder(folder=current_directory, file='user_config')

if run_mainscript:
    # Run analysis through Diana IE
    viia_start_dianaie(file=mainscript_path, close_diana=True)

# =====================================================================================================================
#                                Step 2: runs the analysis in the Command Box
# =====================================================================================================================

if run_analysis:
    # Can be set to specific path by user
    analysis_folder = project.viia_get_latest_model_folder()

    # Result get dat-file and dcf-file
    # Make the default version of A12
    viia_run_diana_command_box(analysis_folder=analysis_folder/signal)

# =====================================================================================================================
#                               Step 3: result collection and post process A12
# =====================================================================================================================

if result_handling:
    # Result collection and post process
    viia_start_dianaie(file=resultscript_path)
